#! usr/bin/python
# -*- coding: utf-8 -*-


import ConfigParser


class MyConfigParser (ConfigParser.ConfigParser):
    
    filename = ""
    
    def __init__ (self, filename):
        self.filename = filename
        ConfigParser.ConfigParser.__init__(self)
        ConfigParser.ConfigParser.read(self, self.filename)
    
    def set(self, section, option, value):
        ConfigParser.ConfigParser.set(self, section, option, value)
        ConfigParser.ConfigParser.write(self, open(self.filename, 'w'))

    def setboolean(self, section, option, value):
        try :
            if (bool(value) == True) :
                self.set(section, option, 'True')
            else :
                self.set(section, option, 'False')
        except :
            self.set(section, option, 'False')
            
            
            
####################  SCRIPT  ####################             

print " --> Installation in progress..."
            
    # Ajout de la section EASE au fichier de configuration
print " -> Add 'EASE' section in the 'config.ini' file .....",
CFG = MyConfigParser('config.ini')

CFG.add_section("EASE")
CFG.set('EASE', 'release', '0')
CFG.set('EASE', 'version', '0')
CFG.set('EASE', 'update_running', 'False')
print "DONE"


    # Ajout du texte dans le fichier langue ENG.ini
print " -> Add information in the language file (ENG.ini) .....",
f = open('language/ENG.ini', 'ab')
f.write(
"""

[EASE_MANAGER]
window_title = EASE List Manager
current_release = Current release :
nb_total_annotations = Nb of annotations :
nb_total_annotated_genes = Nb of genes annotated :
table_functional_class = Functional class
table_first_author = First author
table_date = Date
table_title = Title
labelframe_info_annot = Information
label_functional_class = Functional Class :
label_title = Title :
label_source = Source :
label_pubmed = Pubmed reference :
label_nb_genes = Number of genes :
button_view_genes = View genes
button_add_annotation = ADD
button_edit_annotation = EDIT
button_remove_annotation = REMOVE
button_update = Update
err_server_check_list = Server error :%sUnable to verify if a new list EASE is available.
err_server_download_list = Server error :%sUnable to download the new list EASE.
err_install_list = Unable to install the new liste EASE.
update_install_list = Update in progress. Please wait...

[EASE_MANAGER_GENES_ANNOTATED]
window_title = Genes annotated
label = Annotation :
save = Save
copy = Copy
close = CLOSE

[EASE_MANAGER_ADD_ANNOTATION]
window_title = Add annotation
open_file = Open
paste = Paste
functional_class = Functional class :
author = First author :
date = Date (nothing if unpublished) :
title = Title :
pubmed = Pubmed link :
source = Source :
close = CLOSE
add = ADD

err_no_gene = No gene in the gene list
err_no_functional_class_or_author = "Functional class" and "First author" should not be empty.
err_wrong_id_title = Wrong ID
err_wrong_id = Gene IDs must be WormBase IDs.%sUse the converter if necessary.
err_unknown_gene_title = Gene unknown
err_unknown_gene = Some genes are not recognized in the release WS %d.%sUse the converter if necessary.
err_server_check_list = Server error :%sUnable to verify if a new list EASE is available.%sTry later...
err_server_download_list = Server error :%sUnable to download the new list EASE.%sTry later...
err_install_list = Unable to install the new liste EASE.
update_install_list = Update in progress. Please wait...
err_annotation_already_exists_title = Wrong annotation
err_annotation_already_exists = The annotation already exists in the list EASE.
done_title = New annotation added
done = New annotation has been sent to the server.%sWait a few moments and restart the program to update the EASE list.

[EASE_MANAGER_REMOVE_ANNOTATION]
remove_title = Remove annotation
remove_warning = Annotation : %sAre you sure you want to remove this annotation ?
passwd_label = Password required :
passwd_ok = OK
passwd_cancel = CANCEL
err_passwd_title = Wrong password
err_passwd = The password is incorrect.
done_title = Annotation removed
done = The annotation to be deleted has been sent to the server.%sWait a few moments and restart the program to update the EASE list.

[EASE_MANAGER_EDIT_ANNOTATION]
window_title = Edit annotation
functional_class = Functional class :
author = First author :
date = Date (nothing if unpublished) :
title = Title :
pubmed = Pubmed link :
source = Source :
close = CLOSE
edit = MODIFY
err_no_functional_class_or_author = "Functional class" and "First author" should not be empty.
done_title = Annotation modified
done = The annotation to be modified has been sent to the server.%sWait a few moments and restart the program to update the EASE list.

[EASE_MANAGER_UPDATE]
done_title = Update in progess
done = An application update has been sent to the server.%sWait a few moments and restart the program to update the EASE list.

""")

f.close()
print "DONE"


print " --> Installation complete !"






