#! usr/bin/python
# -*- coding: utf-8 -*-

import ConfigParser, sys, os
import conversion

class MyConfigParser (ConfigParser.ConfigParser):
    """Modification du module 'ConfigParser' pour permettre l'enregistrement en temps réel des modifications."""
    
    filename = ""
    
    def __init__ (self, filename):
        self.filename = filename
        ConfigParser.ConfigParser.__init__(self)
        ConfigParser.ConfigParser.read(self, self.filename)
    
    def set(self, section, option, value):
        """Enregistre une valeur dans une clé d'une section donnée.
           section / option / value : Section / Clé / Valeur souhaitée"""
    
        ConfigParser.ConfigParser.set(self, section, option, value)
        ConfigParser.ConfigParser.write(self, open(self.filename, 'w'))

    def setboolean(self, section, option, value):
        """Enregistre une valeur au format boolean dans une clé d'une section donnée.
           section / option / value : Section / Clé / Valeur souhaitée"""
    
        try :
            if (bool(value) == True) :
                self.set(section, option, 'True')
            else :
                self.set(section, option, 'False')
        except :
            self.set(section, option, 'False')
            
            
        
def add_annotation (file) :
    """Ajoute d'une nouvelle annotation à la liste EASE (avec la liste des gènes assosciés."""

        # Récupère les informations sur la nouvelle annotation
    ADD_FILE = MyConfigParser('ease/temp/' + file)

    __functional_class = ADD_FILE.get('INFORMATIONS', 'functional_class')
    __title = ADD_FILE.get('INFORMATIONS', 'title')
    __author = ADD_FILE.get('INFORMATIONS', 'author')
    __date = ADD_FILE.get('INFORMATIONS', 'date')
    __pubmed = ADD_FILE.get('INFORMATIONS', 'pubmed')
    __source = ADD_FILE.get('INFORMATIONS', 'source')
    __nb_genes = ADD_FILE.getint('GENES', '0')


        # Vérifie que l'annotation n'est pas déjà existante
    f = open('ease/temp/EASE_list_infos.txt', 'rb')
    line = f.readline()     # infos sur la liste EASE
    line = f.readline()
    while (line != "") :
        line = line.strip().split('\t')
        if (line[0].lower() == __functional_class.lower()) and (line[1].lower() == __author.lower()) \
            and (line[2].lower() == __date.lower()) :
                f.close()
                os.remove('ease/temp/' + file)
                return
        line = f.readline()
    f.close()


        # Création de l'annotation telle qu'elle sera dans la liste EASE
    annot = __functional_class + ' ; ' + __author + ' ; ' + __date

    
        # Ajout de l'annotation à la liste des annotations
    EASE_infos = open('ease/temp/EASE_list_infos.txt', 'rb')
    new_EASE_infos = open('ease/temp/EASE_list_infos.txt.tmp', 'wb')

    # informations sur la liste EASE
    line = EASE_infos.readline()
    line = line.strip().split('\t')
    line[1] = line[1].split(':')[0] + ':' + str(int(line[1].split(':')[1]) + 1)
    line[3] = str(int(line[3]) + 1)
    line[5] = str(int(line[5]) + __nb_genes)

    new_EASE_infos.write(line[0] + '\t' + line[1] + '\t' + line[2] + '\t' + line[3] + '\t' + line[4] + \
                         '\t' + line[5] + '\t\r\n')

    # copie de l'anciennce liste EASE
    line = EASE_infos.readline()
    while (line != "") :
        new_EASE_infos.write(line)
        line = EASE_infos.readline()

    # ajout de la nouvelle annotation
    new_EASE_infos.write(__functional_class + '\t' + __author + '\t' + __date + '\t' + __title + '\t' + \
                         __pubmed + '\t' + __source + '\t' + str(__nb_genes) + '\r\n')

    new_EASE_infos.close()
    EASE_infos.close()

        # Ajout des gènes à la liste EASE
    old_EASE_list = open('ease/temp/EASE_list.txt', 'rb')
    new_EASE_list = open('ease/temp/EASE_list.txt.tmp', 'wb')

    # copie de l'ancienne liste
    line = old_EASE_list.readline()
    while (line != "") :
        new_EASE_list.write(line)
        line = old_EASE_list.readline()
    
    old_EASE_list.close()

    # ajout des nouveaux gènes
    for i in range(1, __nb_genes+1):
        new_EASE_list.write(ADD_FILE.get('GENES', str(i)) + '\t"' + annot + '"\r\n')
        
    new_EASE_list.close()


        # Renomme les fichiers temporaires
    os.remove('ease/temp/EASE_list_infos.txt')
    os.rename('ease/temp/EASE_list_infos.txt.tmp', 'ease/temp/EASE_list_infos.txt')
    os.remove('ease/temp/EASE_list.txt')
    os.rename('ease/temp/EASE_list.txt.tmp', 'ease/temp/EASE_list.txt')    


        # Supprime le fichier d'ajout d'annotation
    os.remove('ease/temp/' + file)

    return True



def remove_annotation (file) :
    """Supprime une annotation de la liste EASE."""

        # Récupère les informations sur l'annotation à supprimer
    REM_FILE = MyConfigParser('ease/temp/' + file)

    __functional_class = REM_FILE.get('INFORMATIONS', 'functional_class')
    __author = REM_FILE.get('INFORMATIONS', 'author')
    __date = REM_FILE.get('INFORMATIONS', 'date')
    __nb_genes = REM_FILE.getint('INFORMATIONS', 'nb_genes')


        # Création de l'annotation telle qu'elle sera dans la liste EASE
    annot = __functional_class + ' ; ' + __author + ' ; ' + __date


        # Suppression de l'annotation à la liste des annotations
    EASE_infos = open('ease/temp/EASE_list_infos.txt', 'rb')
    new_EASE_infos = open('ease/temp/EASE_list_infos.txt.tmp', 'wb')

    # informations sur la liste EASE
    line = EASE_infos.readline()
    line = line.strip().split('\t')
    line[1] = line[1].split(':')[0] + ':' + str(int(line[1].split(':')[1]) + 1)
    line[3] = str(int(line[3]) - 1)
    line[5] = str(int(line[5]) - __nb_genes)

    new_EASE_infos.write(line[0] + '\t' + line[1] + '\t' + line[2] + '\t' + line[3] + '\t' + line[4] + \
                         '\t' + line[5] + '\t\r\n')

    # copie de l'anciennce liste EASE
    line = EASE_infos.readline()
    while (line != "") :
        line_s = line
        line = line.strip().split('\t')
        if (line[0].lower() == __functional_class.lower()) and (line[1].lower() == __author.lower()) \
           and (line[2].lower() == __date.lower()) :
            pass
        else :
            new_EASE_infos.write(line_s)
        line = EASE_infos.readline()

    new_EASE_infos.close()
    EASE_infos.close()


        # Recopiage des gènes de la liste EASE (sauf l'annotation supprimée)
    EASE_list = open('ease/temp/EASE_list.txt', 'rb')
    new_EASE_list = open('ease/temp/EASE_list.txt.tmp', 'wb')

    line = EASE_list.readline()
    while (line != "") :
        line_s = line
        line = line.strip().split('\t')
        if (line[1][0] == '"') or (line[1][-1] == '"') : line[1] = line[1][1:-1]
        if (line[1] == annot) :
            pass
        else :
            new_EASE_list.write(line_s)
        line = EASE_list.readline()

    new_EASE_list.close()
    EASE_list.close()


        # Renomme le fichier temporaire (informations sur la liste EASE)
    os.remove('ease/temp/EASE_list_infos.txt')
    os.rename('ease/temp/EASE_list_infos.txt.tmp', 'ease/temp/EASE_list_infos.txt')
    os.remove('ease/temp/EASE_list.txt')
    os.rename('ease/temp/EASE_list.txt.tmp', 'ease/temp/EASE_list.txt')


        # Supprime le fichier de suppression d'annotation
    os.remove('ease/temp/' + file)

    return True



def edit_annotation (file):
    """Modification une annotation présente dans la liste EASE."""

        # Récupère les informations sur l'annotation à supprimer
    MOD_FILE = MyConfigParser('ease/temp/' + file)

    __functional_class__old = MOD_FILE.get('OLD_ANNOTATION', 'functional_class')
    __title__old = MOD_FILE.get('OLD_ANNOTATION', 'title')
    __author__old = MOD_FILE.get('OLD_ANNOTATION', 'author')
    __date__old = MOD_FILE.get('OLD_ANNOTATION', 'date')
    __pubmed__old = MOD_FILE.get('OLD_ANNOTATION', 'pubmed')
    __source__old = MOD_FILE.get('OLD_ANNOTATION', 'source')

    __functional_class__new = MOD_FILE.get('NEW_ANNOTATION', 'functional_class')
    __title__new = MOD_FILE.get('NEW_ANNOTATION', 'title')
    __author__new = MOD_FILE.get('NEW_ANNOTATION', 'author')
    __date__new = MOD_FILE.get('NEW_ANNOTATION', 'date')
    __pubmed__new = MOD_FILE.get('NEW_ANNOTATION', 'pubmed')
    __source__new = MOD_FILE.get('NEW_ANNOTATION', 'source')


        # Création de l'annotation telle qu'elle sera dans la liste EASE
    annot__old = __functional_class__old + ' ; ' + __author__old + ' ; ' + __date__old
    annot__new = __functional_class__new + ' ; ' + __author__new + ' ; ' + __date__new


        # Modification de l'annotation dans la liste des annotations
    EASE_infos = open('ease/temp/EASE_list_infos.txt', 'rb')
    new_EASE_infos = open('ease/temp/EASE_list_infos.txt.tmp', 'wb')

    # informations sur la liste EASE
    line = EASE_infos.readline()
    line = line.strip().split('\t')
    line[1] = line[1].split(':')[0] + ':' + str(int(line[1].split(':')[1]) + 1)

    new_EASE_infos.write(line[0] + '\t' + line[1] + '\t' + line[2] + '\t' + line[3] + '\t' + line[4] + \
                         '\t' + line[5] + '\t\r\n')

    # copie de l'anciennce liste EASE
    line = EASE_infos.readline()
    while (line != "") :
        line_s = line
        line = line.strip().split('\t')
        if (line[0] == __functional_class__old) and (line[1] == __author__old) \
           and (line[2] == __date__old) :
            new_EASE_infos.write(__functional_class__new + '\t' + __author__new + '\t' + __date__new + \
                                 '\t' + __title__new + '\t' + __pubmed__new + '\t' + __source__new + \
                                 '\t' + line[-1] + '\r\n')
        else :
            new_EASE_infos.write(line_s)
        line = EASE_infos.readline()

    new_EASE_infos.close()
    EASE_infos.close()


        # Modification des annotations dans la liste EASE
    EASE_list = open('ease/temp/EASE_list.txt', 'rb')
    new_EASE_list = open('ease/temp/EASE_list.txt.tmp', 'wb')

    line = EASE_list.readline()
    while (line != "") :
        line_s = line
        line = line.strip().split('\t')
        
        try :
            if (line[1][0] == '"') or (line[1][-1] == '"') : line[1] = line[1][1:-1]
            if (line[1] == annot__old) :
                new_EASE_list.write(line[0] + '\t' + annot__new + '\r\n')
            else :
                new_EASE_list.write(line_s)
        except :        # Exception si ligne vide  ('index out of range')
            pass
            
        line = EASE_list.readline()

    new_EASE_list.close()
    EASE_list.close()


        # Renomme le fichier temporaire (informations sur la liste EASE)
    os.remove('ease/temp/EASE_list_infos.txt')
    os.rename('ease/temp/EASE_list_infos.txt.tmp', 'ease/temp/EASE_list_infos.txt')
    os.remove('ease/temp/EASE_list.txt')
    os.rename('ease/temp/EASE_list.txt.tmp', 'ease/temp/EASE_list.txt')
    

        # Supprime le fichier de modification d'annotation
    os.remove('ease/temp/' + file)

    return True
    

    
def modif_EASE_list () :

        # Récupère la liste des fichiers de changements
    files = os.listdir('ease/temp/')
    files = [file for file in files if (file[-1] != '~')]
    files.sort()        # modifie la liste EASE dans l'ordre des changements : ADD -> MOD -> REM

        # Copie la liste EASE actuelle dans le temp/ pour modification
    copy_file('ease/funcLists/EASE_list.txt', 'ease/temp/EASE_list.txt')
    copy_file('ease/funcLists/EASE_list_infos.txt', 'ease/temp/EASE_list_infos.txt')

        # Modification de la liste EASE
    res = False
    if (files[0][:3] == 'ADD') :
        res = add_annotation(files[0])
    elif (files[0][:3] == 'REM') :
        res = remove_annotation(files[0])
    elif (files[0][:3] == 'MOD') :
        res = edit_annotation(files[0])

        # Si la modification a fonctionnée, on modifie la liste pour permettre la MAJ des clients
    if (res == True) :
        copy_file('ease/temp/EASE_list.txt', 'ease/funcLists/EASE_list.txt')
        copy_file('ease/temp/EASE_list_infos.txt', 'ease/funcLists/EASE_list_infos.txt')

        CFG.set('EASE', 'version', str(CFG.getint('EASE', 'version') + 1))
    

    
def update_EASE_list (release):
    """Met à jour la liste EASE vers la version souhaitée.
       release : version souhaitée"""
    
    conv = conversion.Conversion()
    
        # On récupère la liste des anciennes liste EASE (pour les gènes "resurrected")
    old_EASE_lists = os.listdir('ease/funcLists/backup')
    old_EASE_lists = [file for file in old_EASE_lists if (file[-1] != '~')]

    
        # Ouverture des informations sur la liste EASE actuelle
    EASE_list_infos = open('ease/funcLists/EASE_list_infos.txt', 'rb')
    EASE_list_infos.readline()          # informations sur la liste
    
        # Nouvelle liste EASE
    EASE_list_new = open('ease/funcLists/EASE_list.txt.tmp', 'wb')    
    
        # Pour chaque annotation, on regarde tous les gènes associés
    EASE_annotations = []               # liste des annotations présentes dans la liste EASE (avec nb gènes, ...)
    nb_genes_annotated = 0              # nb de gènes annotés dans la nouvelle liste
    
    line = EASE_list_infos.readline()
    while (line != "") :
        
            # Séparation des informations sur l'annotation
        line = line.strip().split('\t')
        
            # Création de l'annotation telle qu'elle est dans la liste EASE
        annot = line[0] + ' ; ' + line[1] + ' ; ' + line[2]
        
            # On parcourt la liste EASE pour rechercher les gènes contenant cette annotation
        gene_list_old = []
            
        EASE_list = open('ease/funcLists/EASE_list.txt', 'rb')
        
        line2 = EASE_list.readline()
        while (line2 != "") :
            line2 = line2.strip().split('\t')

            if (line2 != ['']) and (line2[1] == annot) :
                gene_list_old.append(line2[0])
                
            line2 = EASE_list.readline()
            
        EASE_list.close()
        
        
            # On convertit chaque gène de cette annotation dans la nouvelle release
        res = conv.update_geneIDs(gene_list_old, release-1, True)
        gene_list_new = []
        for result in res[0] :
            if (result[2] != '') :
                gene_list_new.append(result[2])
            
            # On recherche la présence de gènes "resurrected" qui possédaient l'annotation
        genes_resurrected = res[1]
        genes_added = []
        
        for file in old_EASE_lists :
            
            f = open('ease/funcLists/backup/' + file, 'rb')
            
            line3 = f.readline()
            while (line3 != "") :
                line3 = line3.strip().split('\t')
            
                if (line3[1] == annot) and (line3[0] in genes_resurrected) :
                    genes_added.append(line3[0])
            
                line3 = f.readline()
                
            f.close()
            
        gene_list_new = list(set(gene_list_new + genes_added))      # ajout des gènes ressuscités, élimine les doublons
        

            # Ajout des gènes dans la nouvelle liste EASE
        for gene in gene_list_new :
            EASE_list_new.write(gene + '\t' + annot + '\r\n')
       
        
            # Enregistrement des informations sur l'annotation
        EASE_annotations.append(line[0] + '\t' + line[1] + '\t' + line[2] + '\t' + line[3] + '\t' + line[4] + '\t' + \
                                line[5] + '\t' + str(len(gene_list_new)))
        
        nb_genes_annotated = nb_genes_annotated + len(gene_list_new)


        line = EASE_list_infos.readline()
        
    EASE_list_new.close()        
    EASE_list_infos.close()


        # Création du fichier d'informations sur la nouvelle liste EASE
    EASE_list_infos_new = open('ease/funcLists/EASE_list_infos.txt.tmp', 'wb')
    
    EASE_list_infos_new.write("Release :\t" + str(release) + ":1\tNb annotations :\t" + str(len(EASE_annotations)) + '\t' + \
                              "Nb annotated genes :\t" + str(nb_genes_annotated) + '\t\r\n')
    
    for annotation in EASE_annotations :
        EASE_list_infos_new.write(annotation + '\r\n')
        
    EASE_list_infos_new.close()
    

        # Déplacement de l'ancienne liste vers le dossier BACKUP
    os.rename('ease/funcLists/EASE_list.txt', 'ease/funcLists/backup/EASE_list_WS' + str(release-1) + '.txt')
    os.rename('ease/funcLists/EASE_list_infos.txt', 'ease/funcLists/backup/EASE_list_infos_WS' + str(release-1) + '.txt')
    os.rename('ease/funcLists/EASE_list.txt.tmp', 'ease/funcLists/EASE_list.txt')
    os.rename('ease/funcLists/EASE_list_infos.txt.tmp', 'ease/funcLists/EASE_list_infos.txt')
    
    
        # Mise à jour du fichier de configuration
    CFG.set('EASE', 'release', str(release))
    CFG.set('EASE', 'version', '1')    
    

    
def copy_file (src, dest) :
    """Copie le fichier source 'src' vers le fichier de destination 'dest'."""

    os.system("chmod a+wr " + src)
    os.rename(src, dest)



def get_last_WB_release_freeze () :
    """Récupère la dernière release freeze installée de WormBase."""
    
        # Récupération de la liste des toutes les releases
    WB_releases = CFG.get('WORMBASE', 'releases')
    WB_releases = WB_releases.strip().split(',')
    for i in range(len(WB_releases)) :
        WB_releases[i] = int(WB_releases[i])
        
        # Tri de la liste dans l'ordre décroissant
    WB_releases.sort()
    WB_releases.reverse()
    
        # Recherche la plus récente release freeze
    last_freeze = 0
    for r in WB_releases :
        if (r % 10 == 0) :
            last_freeze = r
            break
        
    return last_freeze

    
    
    
    
#################### SCRIPT ####################
#
#   actions : 
#       'ADD' => Ajout d'une nouvelle annotation à la liste EASE
#       'MOD' => Modification d'une annotation de la liste EASE
#       'REM' => Suppression d'une annotation de la liste EASE
#
#       'UPDATE' => Mise à jour de la liste EASE (uniquement vers une version freeze supérieure)
#

action = sys.argv[1]

CFG = MyConfigParser('config.ini')


    # Vérifie q'une modification n'est pas déjà en cours
if (CFG.getboolean('EASE', 'update_running') == True) :
    sys.exit()
else :
    CFG.set('EASE', 'update_running', 'True')


    # Si demande de modification de la liste ease (ajout, suppression ou édition)
if (action == 'ADD') or (action == 'REM') or (action == 'MOD') :

    while (True) :
            # modification de la liste ease
        modif_EASE_list()

            # récupération de la liste de toutes les modifications à effectuer
        files = os.listdir('ease/temp/')
        files = [file for file in files if (file[-1] != '~')]
        
        if (len(files) == 0) : break


    # Si demande de MAJ de la liste EASE
elif (action == 'UPDATE') :

        # Récupération des versions actuelles
    actual_EASE_release = CFG.getint('EASE', 'release')
    actual_WormBase_release = get_last_WB_release_freeze()

        # Mise à jour de la liste EASE
    for i in range(actual_EASE_release+1, actual_WormBase_release+1) :
        update_EASE_list(i)
        
        # Suppression des fichiers intermédiaires
    for i in range(actual_EASE_release+1, actual_WormBase_release) :
        if (i % 10 == 0) : continue
        else :
            os.remove('ease/funcLists/backup/EASE_list_WS' + str(i) + '.txt')
            os.remove('ease/funcLists/backup/EASE_list_infos_WS' + str(i) + '.txt')


    # Fin de la modification
CFG.set('EASE', 'update_running', 'False')

    
